# This file was created automatically by SWIG.
import pypropertywrapperc
from ooflib.SWIG.engine.properties import PropertyPtr
from ooflib.SWIG.engine.element import ElementDataPtr
class PyPropertyWrapperPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,pypropertywrapperc=pypropertywrapperc):
        if self.thisown == 1 :
            pypropertywrapperc.delete_PyPropertyWrapper(self)
    def __repr__(self):
        return "<C PyPropertyWrapper instance at %s>" % (self.this,)
class PyPropertyWrapper(PyPropertyWrapperPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(pypropertywrapperc.new_PyPropertyWrapper,_args,_kwargs)
        self.thisown = 1




class PyPropertyElementDataPtr(ElementDataPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def data(self, *_args, **_kwargs):
        val = apply(pypropertywrapperc.PyPropertyElementData_data,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C PyPropertyElementData instance at %s>" % (self.this,)
class PyPropertyElementData(PyPropertyElementDataPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(pypropertywrapperc.new_PyPropertyElementData,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: pypropertywrapper.spy,v $
# $Revision: 1.12.8.1 $
# $Author: reida $
# $Date: 2008-12-15 19:31:03 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# These are the Pythonized wrappers for the virtual functions
# of the Property class, as seen from Python.  They are called
# back from the C++ PyPropertyWrapper class, and in turn call
# the corresponding methods of the derived pure-Python
# property.  Their primary function is to wrap their arguments
# in <whatever>Ptr constructors, so all the SWIG'd methods
# are available in the derived-class routine.

from ooflib.SWIG.common import ooferror
from ooflib.SWIG.engine import csubproblem
from ooflib.SWIG.engine import element
from ooflib.SWIG.engine import elementnodeiterator
from ooflib.SWIG.engine import femesh
from ooflib.SWIG.engine import flux
from ooflib.SWIG.engine import mastercoord
from ooflib.SWIG.engine import material
from ooflib.SWIG.engine import outputval
from ooflib.SWIG.engine.IO import propertyoutput
from ooflib.common import debug

ElementFuncNodeIteratorPtr = elementnodeiterator.ElementFuncNodeIteratorPtr
CSubProblemPtr = csubproblem.CSubProblemPtr
FluxDataPtr = flux.FluxDataPtr
FluxPtr = flux.FluxPtr
MasterPositionPtr = mastercoord.MasterPositionPtr
MaterialPtr = material.MaterialPtr

def _PyPropertyWrapper_integration_orderwrap(self, subp_p, element_p):
    if hasattr(self, 'integration_order'):
        msh = CSubProblemPtr(subp_p)
        elmnt = element.ElementPtr(element_p)
        return self.integration_order(msh, elmnt)
    raise ooferror.ErrSetupError("Property " + self.name() +
                                 " is missing the integration_order function!")


PyPropertyWrapperPtr.integration_orderwrap = _PyPropertyWrapper_integration_orderwrap
        
def _PyPropertyWrapper_precomputewrap(self):
    if hasattr(self,'precompute'):
        self.precompute()

PyPropertyWrapperPtr.precomputewrap = _PyPropertyWrapper_precomputewrap

def _PyPropertyWrapper_constant_in_space_wrap(self):
    if hasattr(self, 'constant_in_space'):
        return self.constant_in_space()
    raise ooferror.ErrSetupError("Property " + self.name() +
                                 " is missing the constant_in_space function!")

PyPropertyWrapperPtr.constant_in_space_wrap = _PyPropertyWrapper_constant_in_space_wrap

def _PyPropertyWrapper_cross_referencewrap(self, material_p):
    if hasattr(self,'cross_reference'):
        material = MaterialPtr(material_p)
        self.cross_reference(material)

PyPropertyWrapperPtr.cross_referencewrap = _PyPropertyWrapper_cross_referencewrap


def _PyPropertyWrapper_begin_elementwrap(self, subp_p, element_p):
    if hasattr(self,'begin_element'):
        subp = CSubProblemPtr(subp_p)
        elmnt = element.ElementPtr(element_p)
        self.begin_element(subp, elmnt)

PyPropertyWrapperPtr.begin_elementwrap = _PyPropertyWrapper_begin_elementwrap


def _PyPropertyWrapper_end_elementwrap(self, subp_p, element_p):
    if hasattr(self,'end_element'):
        subp = CSubProblemPtr(subp_p)
        elmnt = element.ElementPtr(element_p)
        self.end_element(subp, elmnt)

PyPropertyWrapperPtr.end_elementwrap = _PyPropertyWrapper_end_elementwrap


def _PyPropertyWrapper_begin_pointwrap(self, mesh_p, element_p,
                                       flux_p, masterpos_p):
    if hasattr(self,'begin_point'):
        mesh = femesh.FEMesh(mesh_p)
        elmnt = element.ElementPtr(element_p)
        flux = FluxPtr(flux_p)
        masterpos =- MasterPositionPtr(masterpos_p)
        self.begin_point(mesh, elmnt, flux, masterpos)

PyPropertyWrapperPtr.begin_pointwrap = _PyPropertyWrapper_begin_pointwrap


def _PyPropertyWrapper_end_pointwrap(self, mesh_p, element_p,
                                     flux_p, masterpos_p):
    if hasattr(self,'end_point'):
        mesh = femesh.FEMesh(mesh_p)
        elmnt = element.ElementPtr(element_p)
        flux = FluxPtr(flux_p)
        masterpos =- MasterPositionPtr(masterpos_p)
        self.end_point(mesh, elmnt, flux, masterpos)

PyPropertyWrapperPtr.end_pointwrap = _PyPropertyWrapper_end_pointwrap


def _PyPropertyWrapper_post_processwrap(self, subp_p, element_p):
    if hasattr(self,'post_process'):
        subp = CSubProblemPtr(subp_p)
        elmnt = element.ElementPtr(element_p)
        self.post_process(subp, elmnt)

PyPropertyWrapperPtr.post_processwrap = _PyPropertyWrapper_post_processwrap


def _PyPropertyWrapper_fluxmatrixwrap(self, mesh_p, element_p,
                                      efni_p, flux_p, fluxdata_p, masterpos_p):
    if hasattr(self,'fluxmatrix'):
        mesh = femesh.FEMesh(mesh_p)
        elmnt = element.ElementPtr(element_p)
        efni = ElementFuncNodeIteratorPtr(efni_p)
        flux = FluxPtr(flux_p)
        fluxdata = FluxDataPtr(fluxdata_p)
        masterpos = MasterPositionPtr(masterpos_p)
        self.fluxmatrix(mesh, elmnt, efni, flux, fluxdata, masterpos)
        
PyPropertyWrapperPtr.fluxmatrixwrap = _PyPropertyWrapper_fluxmatrixwrap

    
def _PyPropertyWrapper_fluxrhswrap(self, mesh_p, element_p,
                                  flux_p, fluxdata_p, masterpos_p):
    if hasattr(self,'fluxrhs'):
        mesh = femesh.FEMesh(mesh_p)
        elmnt = element.ElementPtr(element_p)
        flux = FluxPtr(flux_p)
        fluxdata = FluxDataPtr(fluxdata_p)
        masterpos = MasterPositionPtr(masterpos_p)
        self.fluxrhs(mesh, elmnt, flux, fluxdata, masterpos)

PyPropertyWrapperPtr.fluxrhswrap = _PyPropertyWrapper_fluxrhswrap


def _PyPropertyWrapper_outputwrap(self, mesh_p, element_p, propout_p, pos_p):
    if hasattr(self, 'output'):
        mesh = femesh.FEMesh(mesh_p)
        elmnt = element.ElementPtr(element_p)
        propout = propertyoutput.PropertyOutputPtr(propout_p)
        position = MasterPositionPtr(pos_p)
        return self.output(mesh, elmnt, propout, position)

PyPropertyWrapperPtr.outputwrap = _PyPropertyWrapper_outputwrap


# Utility functions to support storing data in an element.
def _PyPropertyWrapper_data_to_element(self, element, name, data):
    pass

# Sensible display string for element data.
def _PyPropertyElementData___repr__(self):
    return "PyPropertyElementData(%s,%s)" % (self.name(), `self.data()`)

PyPropertyElementDataPtr.__repr__ = _PyPropertyElementData___repr__


# C++ PyPropertyWrapper objects need access to "self", since they
# store a reference to the Python object.  Instead of passing it in
# twice, we redefine the SWIG-generated __init__ to use the single
# argument in two ways.
def _PyPropertyWrapper___init__(self, *args, **kwargs):
    realargs = (self,)+args
    self.this = apply(pypropertywrapperc.new_PyPropertyWrapper,realargs,kwargs)
    self.thisown = 1

PyPropertyWrapper.__init__ = _PyPropertyWrapper___init__

