// -*- C++ -*-
// $RCSfile: matrixbase.C,v $
// $Revision: 1.1.2.1 $
// $Author: langer $
// $Date: 2010-05-13 20:57:17 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "engine/matrixbase.h"

bool MatrixBase::is_symmetric(double tol) const {
  bool ok = true;
  for(int i=0; i<nrows(); i++)
    for(int j=0; j<ncols(); j++) {
      double one = operator()(i,j);
      double other = operator()(j,i);
      if(fabs(one-other) > 0.5*tol*(one+other) && fabs(one-other) > tol) {
	std::cerr << "Asymmetric matrix! " << i << " " << j 
		  << " " << one << " != " << other
		  << " sum=" << one + other
		  << std::endl;
	ok = false;
      }
    }
  return ok;
}
